Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.amazonaws.services.sqs
Interface AmazonSQS

All Known Subinterfaces:
  AmazonSQSAsync

All Known Implementing Classes:
  AmazonSQSAsyncClient, AmazonSQSClient

    public interface AmazonSQS

Interface for accessing AmazonSQS.

Amazon Simple Queue Service (Amazon SQS) offers a reliable, highly scalable, hosted queue for storing messages as they travel between computers. By using Amazon SQS, developers can simply move data between distributed components of their applications that perform different tasks, without losing messages or requiring each component to be always available. Amazon SQS makes it easy to build an automated workflow, working in close conjunction with the Amazon Elastic Compute Cloud (Amazon EC2) and the other AWS infrastructure web services.

Amazon SQS works by exposing Amazon's web-scale messaging infrastructure as a web service. Any computer on the Internet can add or read messages without any installed software or special firewall configurations. Components of applications using Amazon SQS can run independently, and do not need to be on the same network, developed with the same technologies, or running at the same time.

Visit http://aws.amazon.com/sqs/ for more information.

Method Summary
`void` | `addPermission(AddPermissionRequest addPermissionRequest)` The AddPermission action adds a permission to a queue for a specific principal.
`void` | `changeMessageVisibility(ChangeMessageVisibilityRequest changeMessageVisibilityRequest)` The ChangeMessageVisibility action changes the visibility timeout of a specified message in a queue to a new value.
`CreateQueueResult` | `createQueue(CreateQueueRequest createQueueRequest)` The CreateQueue action creates a new queue, or returns the URL of an existing one.
`void` | `deleteMessage(DeleteMessageRequest deleteMessageRequest)` The DeleteMessage action unconditionally removes the specified message from the specified queue.
`void` | `deleteQueue(DeleteQueueRequest deleteQueueRequest)` This action unconditionally deletes the queue specified by the queue URL.
`GetQueueAttributesResult` | `getQueueAttributes(GetQueueAttributesRequest getQueueAttributesRequest)` Gets one or all attributes of a queue.
`ListQueuesResult` | `listQueues()` The ListQueues action returns a list of your queues.
`ListQueuesResult` | `listQueues(ListQueuesRequest listQueuesRequest)` The ListQueues action returns a list of your queues.
`ReceiveMessageResult` | `receiveMessage(ReceiveMessageRequest receiveMessageRequest)` Retrieves one or more messages from the specified queue, including the message body and message ID of each message.
`void` | `removePermission(RemovePermissionRequest removePermissionRequest)` The RemovePermission action revokes any permissions in the queue policy that matches the specified Label parameter.
`SendMessageResult` | `sendMessage(SendMessageRequest sendMessageRequest)` The SendMessage action delivers a message to the specified queue.
`void` | `setEndpoint(String endpoint)` Overrides the default endpoint for this client ("https://queue.amazonaws.com").
`void` | `setQueueAttributes(SetQueueAttributesRequest setQueueAttributesRequest)` Sets an attribute of a queue.
`void` | `shutdown()` Shuts down this client object, releasing any resources that might be held open.

Method Detail

### setEndpoint

    void setEndpoint(String endpoint)
                     throws IllegalArgumentException

  Overrides the default endpoint for this client ("https://queue.amazonaws.com"). Callers can use this method to control which AWS region they want to work with.

  Callers can pass in just the endpoint (ex: "ec2.amazonaws.com") or a full URL, including the protocol (ex: "https://ec2.amazonaws.com"). If the protocol is not specified here, the default protocol from this client's `ClientConfiguration` will be used, which by default is HTTPS.

  For more information on using AWS regions with the AWS SDK for Java, and a complete list of all available endpoints for all AWS services, see: http://developer.amazonwebservices.com/connect/entry.jspa?externalID=3912

  Parameters:
    `endpoint` - The endpoint (ex: "ec2.amazonaws.com") or a full URL, including the protocol (ex: "https://ec2.amazonaws.com") of the region specific AWS endpoint this client will communicate with.
  Throws:
    `IllegalArgumentException` - If any problems are detected with the specified endpoint.

### listQueues

    ListQueuesResult listQueues(ListQueuesRequest listQueuesRequest)
                                throws AmazonServiceException,
                                       AmazonClientException

  The ListQueues action returns a list of your queues.

  Parameters:
    `listQueuesRequest` - Container for the necessary parameters to execute the ListQueues service method on AmazonSQS.
  Returns:
    The response from the ListQueues service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### setQueueAttributes

    void setQueueAttributes(SetQueueAttributesRequest setQueueAttributesRequest)
                            throws AmazonServiceException,
                                   AmazonClientException

  Sets an attribute of a queue. Currently, you can set only the VisibilityTimeout attribute for a queue.

  Parameters:
    `setQueueAttributesRequest` - Container for the necessary parameters to execute the SetQueueAttributes service method on AmazonSQS.
  Throws:
    `InvalidAttributeNameException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### changeMessageVisibility

    void changeMessageVisibility(ChangeMessageVisibilityRequest changeMessageVisibilityRequest)
                                 throws AmazonServiceException,
                                        AmazonClientException

  The ChangeMessageVisibility action changes the visibility timeout of a specified message in a queue to a new value. The maximum allowed timeout value you can set the value to is 12 hours. This means you can't extend the timeout of a message in an existing queue to more than a total visibility timeout of 12 hours. (For more information visibility timeout, see Visibility Timeout in the Amazon SQS Developer Guide.)

  For example, let's say you have a message and its default message visibility timeout is 30 minutes. You could call ChangeMessageVisiblity with a value of two hours and the effective timeout would be two hours and 30 minutes. When that time comes near you could again extend the time out by calling ChangeMessageVisiblity, but this time the maximum allowed timeout would be 9 hours and 30 minutes.

  IMPORTANT: If you attempt to set the VisibilityTimeout to an amount more than the maximum time left, Amazon SQS returns an error. It will not automatically recalculate and increase the timeout to the maximum time remaining.

  IMPORTANT: Unlike with a queue, when you change the visibility timeout for a specific message, that timeout value is applied immediately but is not saved in memory for that message. If you don't delete a message after it is received, the visibility timeout for the message the next time it is received reverts to the original timeout value, not the value you set with the ChangeMessageVisibility action.

  Parameters:
    `changeMessageVisibilityRequest` - Container for the necessary parameters to execute the ChangeMessageVisibility service method on AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### createQueue

    CreateQueueResult createQueue(CreateQueueRequest createQueueRequest)
                                  throws AmazonServiceException,
                                         AmazonClientException

  The CreateQueue action creates a new queue, or returns the URL of an existing one. When you request CreateQueue, you provide a name for the queue. To successfully create a new queue, you must provide a name that is unique within the scope of your own queues. If you provide the name of an existing queue, a new queue isn't created and an error isn't returned. Instead, the request succeeds and the queue URL for the existing queue is returned.

  IMPORTANT: If you provide a value for DefaultVisibilityTimeout that is different from the value for the existing queue, you receive an error.

  Parameters:
    `createQueueRequest` - Container for the necessary parameters to execute the CreateQueue service method on AmazonSQS.
  Returns:
    The response from the CreateQueue service method, as returned by AmazonSQS.
  Throws:
    `QueueNameExistsException`
    `QueueDeletedRecentlyException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### removePermission

    void removePermission(RemovePermissionRequest removePermissionRequest)
                          throws AmazonServiceException,
                                 AmazonClientException

  The RemovePermission action revokes any permissions in the queue policy that matches the specified Label parameter. Only the owner of the queue can remove permissions.

  Parameters:
    `removePermissionRequest` - Container for the necessary parameters to execute the RemovePermission service method on AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### getQueueAttributes

    GetQueueAttributesResult getQueueAttributes(GetQueueAttributesRequest getQueueAttributesRequest)
                                                throws AmazonServiceException,
                                                       AmazonClientException

  Gets one or all attributes of a queue. Queues currently have two attributes you can get: ApproximateNumberOfMessages and VisibilityTimeout.

  Parameters:
    `getQueueAttributesRequest` - Container for the necessary parameters to execute the GetQueueAttributes service method on AmazonSQS.
  Returns:
    The response from the GetQueueAttributes service method, as returned by AmazonSQS.
  Throws:
    `InvalidAttributeNameException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### addPermission

    void addPermission(AddPermissionRequest addPermissionRequest)
                       throws AmazonServiceException,
                              AmazonClientException

  The AddPermission action adds a permission to a queue for a specific principal. This allows for sharing access to the queue.

  When you create a queue, you have full control access rights for the queue. Only you (as owner of the queue) can grant or deny permissions to the queue. For more information about these permissions, see Shared Queues in the Amazon SQS Developer Guide.

  Parameters:
    `addPermissionRequest` - Container for the necessary parameters to execute the AddPermission service method on AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### deleteQueue

    void deleteQueue(DeleteQueueRequest deleteQueueRequest)
                     throws AmazonServiceException,
                            AmazonClientException

  This action unconditionally deletes the queue specified by the queue URL. Use this operation WITH CARE! The queue is deleted even if it is NOT empty.

  Parameters:
    `deleteQueueRequest` - Container for the necessary parameters to execute the DeleteQueue service method on AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### deleteMessage

    void deleteMessage(DeleteMessageRequest deleteMessageRequest)
                       throws AmazonServiceException,
                              AmazonClientException

  The DeleteMessage action unconditionally removes the specified message from the specified queue. Even if the message is locked by another reader due to the visibility timeout setting, it is still deleted from the queue.

  Parameters:
    `deleteMessageRequest` - Container for the necessary parameters to execute the DeleteMessage service method on AmazonSQS.
  Throws:
    `ReceiptHandleIsInvalidException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### sendMessage

    SendMessageResult sendMessage(SendMessageRequest sendMessageRequest)
                                  throws AmazonServiceException,
                                         AmazonClientException

  The SendMessage action delivers a message to the specified queue.

  Parameters:
    `sendMessageRequest` - Container for the necessary parameters to execute the SendMessage service method on AmazonSQS.
  Returns:
    The response from the SendMessage service method, as returned by AmazonSQS.
  Throws:
    `InvalidMessageContentsException`
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### receiveMessage

    ReceiveMessageResult receiveMessage(ReceiveMessageRequest receiveMessageRequest)
                                        throws AmazonServiceException,
                                               AmazonClientException

  Retrieves one or more messages from the specified queue, including the message body and message ID of each message. Messages returned by this action stay in the queue until you delete them. However, once a message is returned to a ReceiveMessage request, it is not returned on subsequent ReceiveMessage requests for the duration of the VisibilityTimeout. If you do not specify a VisibilityTimeout in the request, the overall visibility timeout for the queue is used for the returned messages.

  Parameters:
    `receiveMessageRequest` - Container for the necessary parameters to execute the ReceiveMessage service method on AmazonSQS.
  Returns:
    The response from the ReceiveMessage service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### listQueues

    ListQueuesResult listQueues()
                                throws AmazonServiceException,
                                       AmazonClientException

  The ListQueues action returns a list of your queues.

  Returns:
    The response from the ListQueues service method, as returned by AmazonSQS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSQS indicating either a problem with the data in the request, or a server side issue.

### shutdown

    void shutdown()

  Shuts down this client object, releasing any resources that might be held open. This is an optional method, and callers are not expected to call it, but can if they want to explicitly release any open resources. Once a client has been shutdown, it should not be used to make any more requests.

Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010 Amazon Web Services, Inc. All Rights Reserved.